VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.OCX"
Begin VB.Form frmSinus 
   AutoRedraw      =   -1  'True
   Caption         =   "Sinus"
   ClientHeight    =   3765
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6510
   LinkTopic       =   "Form1"
   ScaleHeight     =   251
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   434
   StartUpPosition =   3  'Windows-Standard
   Begin MSComctlLib.Slider Slider2 
      Height          =   435
      Left            =   4200
      TabIndex        =   4
      Top             =   3240
      Width           =   2295
      _ExtentX        =   4048
      _ExtentY        =   767
      _Version        =   393216
      LargeChange     =   45
      Min             =   -180
      Max             =   180
      TickFrequency   =   45
   End
   Begin MSComctlLib.Slider Slider1 
      Height          =   435
      Left            =   4200
      TabIndex        =   0
      Top             =   2760
      Width           =   2295
      _ExtentX        =   4048
      _ExtentY        =   767
      _Version        =   393216
      Min             =   3
      Max             =   100
      SelStart        =   3
      Value           =   3
   End
   Begin VB.OptionButton optNEck 
      Caption         =   "Regelmiges Vieleck"
      Height          =   375
      Left            =   0
      TabIndex        =   3
      Top             =   2760
      Value           =   -1  'True
      Width           =   1875
   End
   Begin VB.OptionButton optSinuskurve 
      Caption         =   "Sinuskurve"
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   3180
      Width           =   1155
   End
   Begin VB.PictureBox picBox 
      AutoRedraw      =   -1  'True
      Height          =   2715
      Left            =   0
      ScaleHeight     =   177
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   429
      TabIndex        =   1
      Top             =   0
      Width           =   6495
   End
   Begin VB.Label lblInfo 
      Height          =   915
      Left            =   1920
      TabIndex        =   5
      Top             =   2760
      Width           =   4575
   End
End
Attribute VB_Name = "frmSinus"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Benjamin Wilger

Option Explicit

Const Pi = 3.141592653
Const toRad = Pi / 180
Const toGrad = 180 / Pi

Private Declare Function FloodFill Lib "gdi32" _
   (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
   ByVal crColor As Long) As Long
   
Private Declare Function CreateSolidBrush Lib "gdi32" _
   (ByVal crColor As Long) As Long

Private Declare Function SelectObject Lib "gdi32" _
   (ByVal hdc As Long, ByVal hObject As Long) As Long

Private Declare Function DeleteObject Lib "gdi32" _
(ByVal hObject As Long) As Long

Private Sub Form_Resize()

    Dim c As Long
    Dim i As Long
    Dim x As Double, y As Double
    Dim n As Integer, r As Integer, hFFBrush As Long
    Dim alpha As Double, beta As Double, s As Double
    
   
    On Error Resume Next
    picBox.Width = Me.ScaleWidth
    picBox.Height = Me.ScaleHeight - 2 * Slider1.Height
    Slider1.Top = picBox.Height
    Slider1.Left = Me.ScaleWidth - Slider1.Width
    Slider2.Top = Slider1.Top + Slider1.Height
    Slider2.Left = Me.ScaleWidth - Slider2.Width
    
    optNEck.Top = picBox.Height + 4
    optSinuskurve.Top = optNEck.Top + optNEck.Height
    lblInfo.Top = picBox.Height + 4
    On Error GoTo 0
    
    If optSinuskurve.Value = True Then
        picBox.Cls
        n = Slider1.Value
        picBox.CurrentY = picBox.ScaleHeight \ 2
        picBox.Cls
        For i = 0 To picBox.ScaleWidth
            x = i
            y = Sin(i / picBox.ScaleWidth * 360 * n * Pi / 180) * _
               (picBox.ScaleHeight \ 2 - 6)
               
            If i = 0 Then
                picBox.Line (x, picBox.ScaleHeight \ 2)- _
                  (x, y + picBox.ScaleHeight / 2)
            Else
                picBox.Line -(x, y + picBox.ScaleHeight / 2)
            End If
        Next i
    Else
        picBox.Cls
        n = Slider1.Value

        If picBox.ScaleWidth < picBox.ScaleHeight Then
            r = picBox.ScaleWidth \ 2 - 10
        Else
            r = picBox.ScaleHeight \ 2 - 10
        End If
        

        picBox.CurrentX = picBox.ScaleWidth \ 2
        picBox.CurrentY = picBox.ScaleHeight \ 2
    
        For i = 0 To 360 Step (360 / n)
            x = Cos((i + Slider2.Value) * toRad) * r
            y = Sin((i + Slider2.Value) * toRad) * r
            picBox.Line -(x + picBox.ScaleWidth \ 2, y + _
               picBox.ScaleHeight \ 2), c
            
            If c = 0 Then
                c = RGB(255, 255, 255)
            Else
                c = 0
            End If

        Next i
        x = Cos(Slider2.Value * toRad) * r
        y = Sin(Slider2.Value * toRad) * r
        picBox.Line -(x + picBox.ScaleWidth \ 2, y + _
         picBox.ScaleHeight \ 2), c
        
        alpha = (360 / n)
        beta = (180 - alpha) / 2
        alpha = alpha * toRad
        beta = beta * toRad
        
        r = 1
        s = (r * Sin(alpha)) / Sin(beta) / 2
        lblInfo.Caption = "r = " & r & "; " & _
            "s = " & Format(s, "#0.000") & vbCr & _
            "U = " & Format(s * n, "#0.000") & vbCr & _
            "alpha = " & Format(alpha * toGrad, "#0.000") & "; " & _
            "beta = " & Format(beta * toGrad, "#0.000")

    End If
    
End Sub
Private Sub optNEck_Click()

   Slider1.Min = 3
   Slider2.Enabled = True
   Form_Resize

End Sub
Private Sub optSinuskurve_Click()

   Slider1.Min = 1
   Slider2.Enabled = False
   Form_Resize

End Sub
Private Sub Slider1_Change()

   Form_Resize

End Sub
Private Sub Slider1_Scroll()

   Form_Resize

End Sub
Private Sub Slider2_Change()

   Form_Resize

End Sub
Private Sub Slider2_Scroll()
   
   Form_Resize

End Sub
